/*
 *	x_window.h
 *	X Window initializations header file
 */

#ifndef	_X_WINDOW_H_

#define	_X_WINDOW_H_

#ifdef	EXTERN
#undef	EXTERN
#endif	/* EXTERN */

#ifdef	_X_WINDOW_C_
#define	EXTERN
#else
#define	EXTERN	extern
#endif

#define LEFT_APPLE_KEY  1
#define RIGHT_APPLE_KEY 2
#define DISK_DRIVE_KEY  3
#define REFRESH_INTERVAL 2000

/*
 *	globals
 */

EXTERN	Display			*theDisplay;
EXTERN	int			theScreen;
EXTERN	long			theScreenDepth;
EXTERN	Window			theRootWindow, theWindow;
EXTERN	long			theBlackPixel, theWhitePixel;
EXTERN	Colormap		theColormap;
EXTERN	GC			theGC;
EXTERN	int			HasBackingStore;
EXTERN	Bool			HasSaveUnders;

/*
 *	function prototyping
 */
void init_X(void);
void quit_X(void);
BOOLEAN getmouse( int*, int* );
void setMousePosition( int, int );
void turnOnCursor(void);
void turnOffCursor(void);
#endif	/* _X_WINDOW_H_ */

